searchNodes=[{"ref":"ESClient.html","title":"ESClient","type":"behaviour","doc":"A minimalistic Elasticsearch client for Elixir. Usage You can call the client directly if you have a config struct. iex&gt; config = %ESClient.Config{base_url: &quot;http://localhost:9201&quot;} ...&gt; ESClient.get!(config, &quot;_cat/health&quot;) #ESClient.Response&lt;...&gt; It&#39;s also possible to pass a list of path segments. ESClient.get!(config, [&quot;_cat&quot;, &quot;health&quot;]) When the location is a tuple, the second element becomes encoded as query params. ESClient.get!(config, {[&quot;_cat&quot;, &quot;health&quot;], verbose: true}) Alternatively, you can use this module to build your own custom client and obtain values from the application config. defmodule MyCustomClient use ESClient, otp_app: :my_app end Don&#39;t forget to add the configuration to your config.exs. use Mix.Config # or import Config config :my_app, MyCustomClient, base_url: &quot;http://localhost:9201&quot;, json_keys: :atoms, json_library: Jason, timeout: 15_000 Then, use your client. iex&gt; MyCustomClient.get!(&quot;_cat/health&quot;) #ESClient.Response&lt;...&gt;"},{"ref":"ESClient.html#c:delete/1","title":"ESClient.delete/1","type":"callback","doc":"Dispatch a DELETE request to the path at the configured endpoint."},{"ref":"ESClient.html#delete/2","title":"ESClient.delete/2","type":"function","doc":"Dispatch a GET request to the path at the configured endpoint."},{"ref":"ESClient.html#c:delete!/1","title":"ESClient.delete!/1","type":"callback","doc":"Dispatch a DELETE request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#delete!/2","title":"ESClient.delete!/2","type":"function","doc":"Dispatch a GET request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#c:get/1","title":"ESClient.get/1","type":"callback","doc":"Dispatch a GET request to the path at the configured endpoint."},{"ref":"ESClient.html#get/2","title":"ESClient.get/2","type":"function","doc":"Dispatch a GET request to the path at the configured endpoint."},{"ref":"ESClient.html#c:get!/1","title":"ESClient.get!/1","type":"callback","doc":"Dispatch a GET request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#get!/2","title":"ESClient.get!/2","type":"function","doc":"Dispatch a GET request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#c:head/1","title":"ESClient.head/1","type":"callback","doc":"Dispatch a HEAD request to the path at the configured endpoint."},{"ref":"ESClient.html#head/2","title":"ESClient.head/2","type":"function","doc":"Dispatch a HEAD request to the path at the configured endpoint."},{"ref":"ESClient.html#c:head!/1","title":"ESClient.head!/1","type":"callback","doc":"Dispatch a HEAD request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#head!/2","title":"ESClient.head!/2","type":"function","doc":"Dispatch a HEAD request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#c:post/1","title":"ESClient.post/1","type":"callback","doc":"Dispatch a POST request to the path at the configured endpoint."},{"ref":"ESClient.html#c:post/2","title":"ESClient.post/2","type":"callback","doc":"Dispatch a POST request to the path at the configured endpoint using the specified request data."},{"ref":"ESClient.html#post/3","title":"ESClient.post/3","type":"function","doc":"Dispatch a POST request to the path at the configured endpoint using the specified request data."},{"ref":"ESClient.html#c:post!/1","title":"ESClient.post!/1","type":"callback","doc":"Dispatch a POST request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#c:post!/2","title":"ESClient.post!/2","type":"callback","doc":"Dispatch a POST request to the path at the configured endpoint using the specified request data. Raises when the request fails."},{"ref":"ESClient.html#post!/3","title":"ESClient.post!/3","type":"function","doc":"Dispatch a POST request to the path at the configured endpoint using the specified request data. Raises when the request fails."},{"ref":"ESClient.html#c:put/1","title":"ESClient.put/1","type":"callback","doc":"Dispatch a PUT request to the path at the configured endpoint."},{"ref":"ESClient.html#c:put/2","title":"ESClient.put/2","type":"callback","doc":"Dispatch a PUT request to the path at the configured endpoint using the specified request data."},{"ref":"ESClient.html#put/3","title":"ESClient.put/3","type":"function","doc":"Dispatch a PUT request to the path at the configured endpoint using the specified request data."},{"ref":"ESClient.html#c:put!/1","title":"ESClient.put!/1","type":"callback","doc":"Dispatch a PUT request to the path at the configured endpoint. Raises when the request fails."},{"ref":"ESClient.html#c:put!/2","title":"ESClient.put!/2","type":"callback","doc":"Dispatch a PUT request to the path at the configured endpoint using the specified request data. Raises when the request fails."},{"ref":"ESClient.html#put!/3","title":"ESClient.put!/3","type":"function","doc":"Dispatch a PUT request to the path at the configured endpoint using the specified request data. Raises when the request fails."},{"ref":"ESClient.html#c:request/2","title":"ESClient.request/2","type":"callback","doc":"Dispatch a request to the path at the configured endpoint using the specified request method."},{"ref":"ESClient.html#c:request/3","title":"ESClient.request/3","type":"callback","doc":"Dispatch a request to the path at the configured endpoint using the specified request method and data."},{"ref":"ESClient.html#request/4","title":"ESClient.request/4","type":"function","doc":"Sends a request with the given verb to the configured endpoint. Examples iex&gt; ESClient.request(config, :get, &quot;_cat/health&quot;) {:ok, %ESClient.Response{body: &quot;...&quot;}} iex&gt; ESClient.request(config, :get, [&quot;_cat&quot;, &quot;health&quot;]) {:ok, %ESClient.Response{body: &quot;...&quot;}} iex&gt; ESClient.request(config, :get, {[&quot;_cat&quot;, &quot;invalid&quot;], foo: &quot;bar&quot;}) {:error, %ESClient.ResponseError{reason: &quot;...&quot;}} iex&gt; ESClient.request(config, :put, &quot;my-index&quot;, %{settings: %{...}}) {:ok, %ESClient.Response{body: &quot;...&quot;}}"},{"ref":"ESClient.html#c:request!/2","title":"ESClient.request!/2","type":"callback","doc":"Dispatch a request to the path at the configured endpoint using the specified request method. Raises when the request fails."},{"ref":"ESClient.html#c:request!/3","title":"ESClient.request!/3","type":"callback","doc":"Dispatch a request to the path at the configured endpoint using the specified request method and data. Raises when the request fails."},{"ref":"ESClient.html#request!/4","title":"ESClient.request!/4","type":"function","doc":"Dispatch a request to the path at the configured endpoint using the specified request method and data. Raises when the request fails. Examples iex&gt; ESClient.request!(config, :get, &quot;_cat/health&quot;) %ESClient.Response{body: &quot;...&quot;} iex&gt; ESClient.request!(config, :get, [&quot;_cat&quot;, &quot;health&quot;]) %ESClient.Response{body: &quot;...&quot;} iex&gt; ESClient.request!(config, :get, {[&quot;_cat&quot;, &quot;invalid&quot;], foo: &quot;bar&quot;}) ** (ESClient.ResponseError) ... iex&gt; ESClient.request!(config, :put, &quot;my-index&quot;, %{settings: %{...}}) %ESClient.Response{body: &quot;...&quot;}"},{"ref":"ESClient.html#t:error/0","title":"ESClient.error/0","type":"type","doc":"Type defining an error that be be returned or raised when sending a request to a resource."},{"ref":"ESClient.html#t:location/0","title":"ESClient.location/0","type":"type","doc":"A type that defines a location on the remote server, allowing optional query parameters."},{"ref":"ESClient.html#t:path/0","title":"ESClient.path/0","type":"type","doc":"A type that defines a String containing path segments separated by slashes or a list of path segments."},{"ref":"ESClient.html#t:path_segments/0","title":"ESClient.path_segments/0","type":"type","doc":"A type that defines a list of path segments."},{"ref":"ESClient.html#t:path_str/0","title":"ESClient.path_str/0","type":"type","doc":"A type that defines a String containing path segments separated by slashes."},{"ref":"ESClient.html#t:req_data/0","title":"ESClient.req_data/0","type":"type","doc":"A type that defines request data."},{"ref":"ESClient.html#t:verb/0","title":"ESClient.verb/0","type":"type","doc":"A type that refers to a HTTP method to perform the request with."},{"ref":"ESClient.CodecError.html","title":"ESClient.CodecError","type":"exception","doc":"An error that is returned or raised when decoding of response data or encoding of request data fails."},{"ref":"ESClient.CodecError.html#t:t/0","title":"ESClient.CodecError.t/0","type":"type","doc":""},{"ref":"ESClient.Config.html","title":"ESClient.Config","type":"module","doc":"A helper module to retrieve configuration values and defaults for the client."},{"ref":"ESClient.Config.html#new/1","title":"ESClient.Config.new/1","type":"function","doc":"Builds a new config. Options :base_url - The URL of the Elasticsearch endpoint. Defaults to http://localhost:9200. :driver - The driver to use to transfer data from and to Elasticsearch. Defaults to ESClient.Drivers.HTTPoison. :json_keys - Determines how to convert keys in decoded JSON objects. Possible values are :atoms, :atoms! and strings (default). Note that the JSON library has to support these options. :json_library - The JSON library that encodes request data and decodes response data. Defaults to Jason. :timeout - The time to wait before aborting a request. Can be a non-negative integer or :infinity. Defaults to 15000 (milliseconds)."},{"ref":"ESClient.Config.html#t:t/0","title":"ESClient.Config.t/0","type":"type","doc":""},{"ref":"ESClient.Driver.html","title":"ESClient.Driver","type":"behaviour","doc":"A behavior that must be implemented by custom Elasticsearch drivers. A driver sends a request to the Elasticsearch endpoint and retrieves the particular response."},{"ref":"ESClient.Driver.html#c:request/5","title":"ESClient.Driver.request/5","type":"callback","doc":"A callback for implementing an own function to send a request to a HTTP endpoint."},{"ref":"ESClient.Driver.html#t:error/0","title":"ESClient.Driver.error/0","type":"type","doc":"A type representing failed response data."},{"ref":"ESClient.Driver.html#t:req_headers/0","title":"ESClient.Driver.req_headers/0","type":"type","doc":"A type representing request headers."},{"ref":"ESClient.Driver.html#t:resp/0","title":"ESClient.Driver.resp/0","type":"type","doc":"A type representing successful response data."},{"ref":"ESClient.Driver.html#t:resp_headers/0","title":"ESClient.Driver.resp_headers/0","type":"type","doc":"A type representing response headers."},{"ref":"ESClient.Drivers.HTTPoison.html","title":"ESClient.Drivers.HTTPoison","type":"module","doc":"An adapter implementation that uses HTTPoison to dispatch requests to Elasticsearch."},{"ref":"ESClient.RequestError.html","title":"ESClient.RequestError","type":"exception","doc":"An error that is returned or raised when the search API returned an error due to a bad request."},{"ref":"ESClient.RequestError.html#t:t/0","title":"ESClient.RequestError.t/0","type":"type","doc":""},{"ref":"ESClient.Response.html","title":"ESClient.Response","type":"module","doc":"A struct containing the response data for an Elasticsearch request."},{"ref":"ESClient.Response.html#t:t/0","title":"ESClient.Response.t/0","type":"type","doc":""},{"ref":"ESClient.ResponseError.html","title":"ESClient.ResponseError","type":"exception","doc":"An error that is returned or raised when the search endpoint returns error details."},{"ref":"ESClient.ResponseError.html#t:t/0","title":"ESClient.ResponseError.t/0","type":"type","doc":""},{"ref":"readme.html","title":"ESClient","type":"extras","doc":"ESClient A minimalistic Elasticsearch client for Elixir."},{"ref":"readme.html#prerequisites","title":"ESClient - Prerequisites","type":"extras","doc":"Elixir &gt;= 1.8 Erlang &gt;= 20"},{"ref":"readme.html#installation","title":"ESClient - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding es_client to your list of dependencies in mix.exs: def deps do [ {:es_client, &quot;~&gt; 0.1&quot;}, # You will also need a JSON library {:jason, &quot;~&gt; 1.1&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/es_client."},{"ref":"readme.html#usage","title":"ESClient - Usage","type":"extras","doc":"You can call the client directly if you have a config struct. config = %ESClient.Config{base_url: &quot;http://localhost:9201&quot;} ESClient.get!(config, &quot;_cat/health&quot;) It&#39;s also possible to pass a list of path segments. ESClient.get!(config, [&quot;_cat&quot;, &quot;health&quot;]) When the location is a tuple, the second element becomes encoded as query params. ESClient.get!(config, {[&quot;_cat&quot;, &quot;health&quot;], verbose: true}) Or you can use this module to build your own custom client and obtain values from the application config. defmodule MyCustomClient use ESClient, otp_app: :my_app end Don&#39;t forget to add the configuration to your config.exs. use Mix.Config # or import Config config :my_app, MyCustomClient, base_url: &quot;http://localhost:9201&quot;, json_keys: :atoms, json_library: Jason, timeout: 15_000 Then, use your client. MyCustomClient.get!(&quot;_cat/health&quot;)"},{"ref":"readme.html#missing-features","title":"ESClient - Missing Features","type":"extras","doc":"Authentication"}]